/*  refresh - refersh single and double layer table, and check lsof's options.
    Copyright (C) 2004  Daniele F.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA  */

/* For bugs or infos please contact me <geekgnele@tin.it> */


#include <libgnome/libgnome.h>
#include <libgnomeui/libgnomeui.h>
#include <stdio.h>
#include <string.h>
#include <time.h>

#include "file_selection.h"
#include "list_int_addr.h"
#include "about.h"
#include "layouts.h"
#include "settings.h"
#include "interface.h"
#include "popupmenu.h"

#define ADD_ROW		gtk_list_store_append (GTK_LIST_STORE(command_info_table), &iter);

#define ADD_ROW2	gtk_list_store_append (GTK_LIST_STORE(l2elem->table), &l2elem->iter);

#define FILL_ROW	gtk_list_store_set (command_info_table, &iter, \
							0, tcp[0], 1, tcp[1], 2, tcp[2], 3, tcp[3], \
							4, tcp[4], 5, tcp[5], 6, tcp[6], 7, tcp[7], \
							8, tcp[8], 9, tcp[9], 10, tcp[10], 11, tcp[11], \
							-1);
							
#define FILL_ROW2	gtk_list_store_set (l2elem->table, &l2elem->iter, \
							0, tcp[1], 1, tcp[2], 2, tcp[3], 3, tcp[4], \
							4, tcp[5], 5, tcp[6], 6, tcp[7], 7, tcp[8], \
							8, tcp[9], 9, tcp[10], 10, tcp[11], -1);


/* autorefresh */
extern guint timeout_id;

/* interface */
extern main_window interface;
extern gchar *commands_lsof;
extern gchar *path;

/* layouts */
extern GtkListStore *liststore_left_command_column;
extern GtkListStore *command_info_table;
extern GtkWidget *vbox_right_panel_side;
extern GtkWidget *view_left_command_column;
extern guint temp_l2elem_selected;
extern gchar *name_fields[];

/* settings */
extern settings_window settings;

/* list_int_addr */
extern GPtrArray *add_list;

/* view_options */
extern gboolean state_fields[12];

/* local */
static gchar *tcp[12];
static layout2_elem *l2elem = NULL;

guint append_num;
GPtrArray *list_command_name;
GPtrArray *list_layout2_table;
gint num_command = 0;


/************************************/
/*      CONTROL FOR SETTINGS        */
/************************************/

static void
control_settings (void)
{

  commands_lsof = " ";
	
/***************/
/*   General   */
/***************/

/* -l */
  if ( gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (settings.id_radio)) )
    commands_lsof = g_strconcat (commands_lsof, " -l ", NULL);

/* -o -s */
  if ( gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (settings.offset_radio)) )
    commands_lsof = g_strconcat (commands_lsof, " -o ", NULL);
  else
    commands_lsof = g_strconcat (commands_lsof, " -s ", NULL);

/* -a */
  if ( gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (settings.and_check)) )
    commands_lsof = g_strconcat (commands_lsof, " -a ", NULL);


/*************/
/*   Files   */
/*************/

/* -c */
  if ( gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (settings.procexe_check)) )
    commands_lsof = g_strconcat (commands_lsof, " -c ", 
  g_strjoinv (" -c ", g_strsplit (gtk_entry_get_text (GTK_ENTRY(settings.procexe_entry)), ",", -1)), NULL);

/* -p */
  if ( gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (settings.procid_check)) )
    commands_lsof =
      g_strconcat (commands_lsof, " -p ", gtk_entry_get_text (GTK_ENTRY(settings.procid_entry)), NULL);

/* -g */
  if ( gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (settings.procpgid_check)) )
    commands_lsof =
      g_strconcat (commands_lsof, " -g ", gtk_entry_get_text (GTK_ENTRY(settings.procpgid_entry)), NULL);


/*****************/
/*   Processes   */
/*****************/

/* +d +D */
  if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (settings.dispdir_check)))
    {
      if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (settings.dispdir_depth_check)))
	commands_lsof =
	  g_strconcat (commands_lsof, " +D ", gtk_entry_get_text (GTK_ENTRY(settings.dispdir_entry)), NULL);
      else
	commands_lsof =
	  g_strconcat (commands_lsof, " +d ", gtk_entry_get_text (GTK_ENTRY(settings.dispdir_entry)), NULL);
    }

/* -d */
  if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (settings.fd_check)))
    {
      if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (settings.fd_include_radio)))
	commands_lsof =
	  g_strconcat (commands_lsof, " -d ", gtk_entry_get_text (GTK_ENTRY(settings.fd_entry)), NULL);
      else
	commands_lsof = g_strconcat (commands_lsof, " -d ^", 
	  g_strjoinv (",^", g_strsplit (gtk_entry_get_text (GTK_ENTRY(settings.fd_entry)), ",", -1)), NULL);
    }

/* -u */
  if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (settings.iduname_check)))
    commands_lsof =
      g_strconcat (commands_lsof, " -u ", gtk_entry_get_text (GTK_ENTRY(settings.iduname_entry)), NULL);

/* +L */
  if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (settings.nlinks_check)))
    commands_lsof =
      g_strconcat (commands_lsof, " +L ", gtk_entry_get_text (GTK_ENTRY(settings.nlinks_entry)), NULL);


/***************/
/*   Network   */
/***************/

/* -i */
  if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (settings.inetaddr_check)))
  {
	  int i=0;
	  node_data *elem;
	  
	  if (add_list->len == 0)
		  commands_lsof = g_strconcat (commands_lsof, " -i ", NULL);
	  
	  else 		  
		  while (i < add_list->len)
		  {
			  elem = g_ptr_array_index(add_list, i);
			  commands_lsof = g_strconcat (commands_lsof, " -i ", elem->option, NULL);
			  i++;
		  }
  }

/* -n */
  if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (settings.ipform_check)))
    commands_lsof = g_strconcat (commands_lsof, " -n ", NULL);

/* -N */
  if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (settings.nfs_check)))
    commands_lsof = g_strconcat (commands_lsof, " -N ", NULL);

/* -P */
  if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (settings.portnumbers_check)))
    commands_lsof = g_strconcat (commands_lsof, " -P ", NULL);

/* -U */
  if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (settings.unixsockets_check)))
    commands_lsof = g_strconcat (commands_lsof, " -U ", NULL);


/**************/
/*   Kernel   */
/**************/

/* -S */
  if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (settings.timeout_check)))
    commands_lsof =
      g_strconcat (commands_lsof, " -S ", gtk_entry_get_text (GTK_ENTRY(settings.timeout_entry)), NULL);

/* -b */
  if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (settings.avoid_check)))
    commands_lsof = g_strconcat (commands_lsof, " -b ", NULL);
}


/***************************************/
/* check for command list append names */
/***************************************/

static void
new_layout2_table (layout2_elem *elem)
{
  GtkTreeSelection *selection;
  GtkCellRenderer *cell;
  GtkTreeViewColumn *column;
	
  int i = 0;

  /* scrolled window for main list */
  elem->lines = 0;
  elem->scrolledwindow = gtk_scrolled_window_new (NULL, NULL);

  gtk_container_add (GTK_CONTAINER (vbox_right_panel_side), elem->scrolledwindow);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (elem->scrolledwindow),
				  GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (elem->scrolledwindow),
				       GTK_SHADOW_OUT);
					   
  /* make main column-list */
  elem->view = gtk_tree_view_new ();
  selection = gtk_tree_view_get_selection (GTK_TREE_VIEW (elem->view));

  gtk_tree_selection_set_mode (selection, GTK_SELECTION_SINGLE);
  elem->table = gtk_list_store_new (11, \
  			G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, \
			G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, \
			G_TYPE_STRING);

  gtk_tree_view_set_rules_hint (GTK_TREE_VIEW (elem->view), TRUE);	/* white - grey alternate */
  
  gtk_tree_view_set_model (GTK_TREE_VIEW (elem->view), GTK_TREE_MODEL (elem->table));

  
  for (i = 0; i < 11; i++)
    {
		cell = gtk_cell_renderer_text_new ();
		column = gtk_tree_view_column_new_with_attributes(name_fields[i+1], cell, "text", i, NULL);
		gtk_tree_view_column_set_resizable(GTK_TREE_VIEW_COLUMN(column), TRUE);
		gtk_tree_view_column_set_visible (column, state_fields[i+1]);
		
		if (i==10)
			gtk_tree_view_column_set_sort_column_id(column, i);
		
		gtk_tree_view_append_column(GTK_TREE_VIEW(elem->view), column);
	}
	
  /* popup menu signals */
  g_signal_connect (G_OBJECT (selection), "changed", G_CALLBACK (catch_pid), NULL);
  g_signal_connect(elem->view, "button-press-event", (GCallback) view_onButtonPressed, NULL);
	
  gtk_widget_show (elem->view);
  gtk_container_add (GTK_CONTAINER (elem->scrolledwindow), elem->view);
	
  return;
}

static void
chk_command_list_add_row (void)
{
  GtkTreeIter iter_command_list;
  gint i;
  gpointer elem;
  gboolean make_new_element = TRUE;

  
  for (i=0; i < list_command_name->len; i++)
  	if ( g_ascii_strcasecmp ( g_ptr_array_index(list_command_name, i), tcp[0]) == 0 )
	{
		make_new_element = FALSE;
		l2elem = g_ptr_array_index (list_layout2_table, i);
		break;
	}

  if (make_new_element == TRUE)
  {
	  /* new table for single command */

	  l2elem = g_malloc (sizeof(layout2_elem));
	  new_layout2_table (l2elem); /* fill fields */
	  g_ptr_array_add (list_layout2_table, (gpointer) l2elem);
		
	  /* add command on left table */
		
	  elem = g_malloc (strlen (tcp[0]));
	  elem = g_strdup (tcp[0]);
	  g_ptr_array_add (list_command_name, (gpointer) elem);
	
	  num_command++;
	  gtk_list_store_append (GTK_LIST_STORE (liststore_left_command_column), &iter_command_list);
	  gtk_list_store_set (liststore_left_command_column, &iter_command_list, 0, num_command, 1, elem, -1);
   }
	
   l2elem->lines++;
   ADD_ROW2
}

static void
chk_command_list_clear (void)
{
	gint i;
	layout2_elem *tmp_elem;
	
	for (i=list_command_name->len-1; i>=0; i--)
  {
	  tmp_elem = g_ptr_array_index (list_command_name, i);
	  
	  gtk_list_store_remove (tmp_elem->table,&tmp_elem->iter);
	  
	  g_ptr_array_remove_index (list_command_name, i);
	  g_free (tmp_elem);
  }
  /* freedom for everythings */
	
  if (i>=0)
	  g_ptr_array_free (list_command_name,FALSE);
}

void
update_clist (void)
{
  gchar readbuf[BUFSIZ];
  gchar readbuf2[12][BUFSIZ];
  gchar readbuf3[12][BUFSIZ];
  gchar *lsof_info[12];
  gchar *tmp2;
  gchar **filter_argv;
	
  gchar fd[10];
	
  gint mod = 1000;
  gint width[12];

  gboolean print = FALSE;
  
  GtkTreeIter iter;
  
  gint i,j;
  gint output=0;
  FILE *fp;
  
  /* free list_command_name */
  temp_l2elem_selected = 0;
  chk_command_list_clear ();
  
  /* start settings for control */
  append_num = 0;
  commands_lsof = NULL;
  control_settings ();
  tmp2 = g_malloc (strlen(commands_lsof));

  if (commands_lsof)
  {
	g_strstrip(commands_lsof);
	  
	i=1;
	j=1;
	tmp2 [0] = commands_lsof[0];
	  
	  while (commands_lsof[i])
	  {
		  if (!((commands_lsof[i]==' ') && (commands_lsof[i-1]==' ')))
		  tmp2 [j++] = commands_lsof[i];
		  i++;
	  }
	  
	  tmp2 [j] = 0;
      commands_lsof = g_strconcat (path, tmp2, NULL);
  }
  else
    commands_lsof = g_strdup (path);
  
  printf ("########### %s\n", commands_lsof);
  
  filter_argv = g_strsplit (commands_lsof," ", -1);
  
  g_free (commands_lsof);
  g_free (tmp2);
  
  memset (fd, 0, sizeof (fd));
  memset (readbuf2, 0, sizeof (readbuf2));
  memset (readbuf3, 0, sizeof (readbuf3));
  
  for (i = 0; i < 12; i++)
    {
      lsof_info[i] = readbuf2[i];
      tcp[i] = readbuf3[i];
      width[i] = 0;
    }

  g_spawn_async_with_pipes (NULL,filter_argv,NULL,0,NULL,NULL,NULL,NULL,&output,NULL,NULL);	
  fp = fdopen (output, "r");
  g_strfreev (filter_argv);

	
  while (fgets (readbuf, BUFSIZ, fp))
    {

      switch (readbuf[0])
	{

	case 'c':
	  {
	    mod = 0;
	    break;
	  }			/* COMMAND */
	case 'p':
	  {
	    mod = 1;
	    break;
	  }			/* PID */
	case 'g':
	  {
	    mod = 2;
	    break;
	  }			/* PGID */
	case 'R':
	  {
	    mod = 3;
	    break;
	  }			/* PPID */

	case 'u':
	  {
	    mod = 4;
	    break;
	  }			/* USER */
	case 'L':
	  {
	    mod = 4;
	    break;
	  }

	case 'f':
	  {
	    mod = 5;
	    strncat (&fd[0], &readbuf[1], strlen (readbuf) - 2);
	    break;
	  }			/* FD */
	case 'a':
	  {
	    mod = 5;
	    strncat (&fd[0], &readbuf[1], strlen (readbuf) - 2);
	    break;
	  }
	case 'l':
	  {
	    mod = 5;
	    strncat (&fd[0], &readbuf[1], strlen (readbuf) - 2);
	    break;
	  }

	case 't':
	  {
	    mod = 6;
	    break;
	  }			/* TYPE */

	case 'd':
	  {
	    mod = 7;
	    break;
	  }			/* DEVICE */
	case 'D':
	  {
	    mod = 7;
	    break;
	  }

	case 'o':
	  {
	    mod = 8;
	    break;
	  }			/* SIZE/OFF */
	case 's':
	  {
	    mod = 8;
	    break;
	  }

	case 'k':
	  {
	    mod = 9;
	    break;
	  }			/* NLINK */

	case 'i':
	  {
	    mod = 10;
	    break;
	  }			/* NODE */
	case 'P':
	  {
	    mod = 10;
	    break;
	  }

	case 'S':
	  {
	    mod = 11;
	    print = TRUE;
	    break;
	  }			/* NAME */
	case 'n':
	  {
	    mod = 11;
	    print = TRUE;
	    break;
	  }
	case 'T':
	  {
		strcat (tcp[11], "(");
	    strncat (tcp[11], &readbuf[1], strlen (readbuf) - 2);
		strcat (tcp[11], ")");
	    break;
	  }

	default:
	  mod = 1000;
	}

      if (mod < 1000 && ((strlen (readbuf) - 2) > width[mod]))
	width[mod] = strlen (readbuf) - 2;

	  if (mod < 1000 && mod != 5)
	    {
	      memset (readbuf2[mod], 0, sizeof (readbuf2[mod]));
	      strncpy (&readbuf2[mod][0], &readbuf[1], strlen (readbuf) - 2);
	      mod = 1000;
	    }

	  if (print == TRUE)
	    {
	      strncpy (&readbuf2[5][0], &fd[0], strlen (fd));
	      memset (fd, 0, sizeof (fd));
			
		  if (strlen (tcp[0])>0)
		  {
			  gboolean add_line_table = TRUE;
			  
			  if ( gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (settings.hideglsof_check)) )
				  if ((!strcmp (tcp[0],"glsof")) || (!strcmp (tcp[0],"lsof")))
					  add_line_table = FALSE;
				  
			  if (add_line_table == TRUE)
				{
					ADD_ROW /* layout 1 */
					FILL_ROW
					append_num++;
					
					chk_command_list_add_row (); /* layout 2 */
					FILL_ROW2
				}
		  }
		  
	      print = FALSE;
	      memset (readbuf3, 0, sizeof (readbuf3));
	      for (i = 0; i < 12; i++)
			strcpy (&readbuf3[i][0], &readbuf2[i][0]);
	      for (i = 5; i < 12; i++)
			memset (readbuf2[i], 0, sizeof (readbuf2[i]));
	    } /* _if (print) */
			
	  memset (readbuf, 0, sizeof (readbuf));
			
	} /* _while */
	
  /*******************************/
  /*     OUT FROM MAIN LOOP      */
  /*******************************/
	
  if (strlen(readbuf) == 0)
	  if ((strcmp (tcp[0],"glsof")) && (strcmp (tcp[0],"lsof")))
		  {
			  ADD_ROW /* layout 1 */
			  FILL_ROW 
			  append_num++;
			
			  chk_command_list_add_row (); /* layout 2 */
			  FILL_ROW2
		  }
		  
  fclose (fp);
}
