/*  settings - save and load datas for 'settings' and make settings-window.
    Copyright (C) 2004  Daniele F.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA  */
	
/* For bugs or infos please contact me <geekgnele@tin.it> */


#include <libgnome/libgnome.h>
#include <libgnomeui/libgnomeui.h>
#include <glade/glade.h>
#include <gconf/gconf.h>
#include <gconf/gconf-client.h>
#include <string.h>

#include "interface.h"
#include "settings.h"
#include "list_int_addr.h"
#include "preferences.h"


/* list_int_addr */
extern list_add lia;
extern GPtrArray *add_list;

/* list_settings */
extern GPtrArray *item_array;

/* main */
extern gchar *path_config;
extern GConfClient *client;

/* extern */
settings_window settings;


/* settings gui signals for hide and show other widgets on check-toggled */

/*********/
/* Files */
/*********/

void
on_procexe_toggled (GtkToggleButton *button, gpointer user_data)
{
	gtk_widget_set_sensitive (settings.procexe_entry,
	gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (settings.procexe_check)));
}

void
on_procid_toggled (GtkToggleButton *button, gpointer user_data)
{
	gtk_widget_set_sensitive (settings.procid_entry,
	gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (settings.procid_check)));
}

void
on_procpgid_toggled (GtkToggleButton *button, gpointer user_data)
{
	gtk_widget_set_sensitive (settings.procpgid_entry,
	gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (settings.procpgid_check)));
}


/*************/
/* Processes */
/*************/

void
on_dispdir_toggled (GtkToggleButton *button, gpointer user_data)
{
	gboolean state = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (settings.dispdir_check));
	
	gtk_widget_set_sensitive (settings.dispdir_entry,state);
	gtk_widget_set_sensitive (settings.dispdir_depth_check,state);
}

void
on_fd_toggled (GtkToggleButton *button, gpointer user_data)
{
	gboolean state = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (settings.fd_check));
	
	gtk_widget_set_sensitive (settings.fd_entry,state);
	gtk_widget_set_sensitive (settings.fd_include_radio,state);
	gtk_widget_set_sensitive (settings.fd_exclude_radio,state);
}

void
on_iduname_toggled (GtkToggleButton *button, gpointer user_data)
{
	gtk_widget_set_sensitive (settings.iduname_entry,
	gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (settings.iduname_check)));
}

void
on_nlinks_toggled (GtkToggleButton *button, gpointer user_data)
{
	gtk_widget_set_sensitive (settings.nlinks_entry,
	gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (settings.nlinks_check)));
}

/***********/
/* Network */
/***********/

void
on_inetaddr_toggled (GtkToggleButton *button, gpointer user_data)
{
	gtk_widget_set_sensitive (settings.inetaddr_button,
	gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (settings.inetaddr_check)));
}

/**********/
/* Kernel */
/**********/

void
on_timeout_toggled (GtkToggleButton *button, gpointer user_data)
{
	gtk_widget_set_sensitive (settings.timeout_entry,
	gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (settings.timeout_check)));
}


/***********************/
/* Ok & Cancel Signals */
/***********************/

void
on_settings_close (GtkButton * button, gpointer user_data)
{
  save_sets();
  gtk_widget_hide (GTK_WIDGET (settings.window));
}


/* load and save settings */
void
load_sets (void)
{
  GSList *list_strings;
  guint list_length;
	
  /* general - id or login */
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (settings.id_radio),	
	  gconf_client_get_bool (client, gconf_concat_dir_and_key (settings.gconf_path_settings, "id"), NULL) );
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (settings.login_radio), 
	  gconf_client_get_bool (client, gconf_concat_dir_and_key (settings.gconf_path_settings, "login"), NULL) );
	  
  /* general - offset or size */
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (settings.offset_radio), 
	  gconf_client_get_bool (client, gconf_concat_dir_and_key (settings.gconf_path_settings, "offset"), NULL) );
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (settings.size_radio),
	  gconf_client_get_bool (client, gconf_concat_dir_and_key (settings.gconf_path_settings, "size"), NULL) );

  /* general - all AND */
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (settings.and_check),	
	  gconf_client_get_bool (client, gconf_concat_dir_and_key (settings.gconf_path_settings, "and"), NULL) );

  /* general - hide 'lsof' and 'glsof' from output*/
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (settings.hideglsof_check), 
      gconf_client_get_bool (client, gconf_concat_dir_and_key (settings.gconf_path_settings, "hideglsof"), NULL) );
	  
  /* files - processes name exec */
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (settings.procexe_check),	
  gconf_client_get_bool (client, gconf_concat_dir_and_key (settings.gconf_path_settings, "procexe"), NULL) );
  gtk_entry_set_text (GTK_ENTRY (settings.procexe_entry), 
  gconf_client_get_string (client, gconf_concat_dir_and_key (settings.gconf_path_settings, "procexe_entry"), NULL) );
  
  /* files - processes ID */
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (settings.procid_check),	
  gconf_client_get_bool (client, gconf_concat_dir_and_key (settings.gconf_path_settings, "procid"), NULL) );
  gtk_entry_set_text (GTK_ENTRY (settings.procid_entry), 
  gconf_client_get_string (client, gconf_concat_dir_and_key (settings.gconf_path_settings, "procid_entry"), NULL) );
  
  /* files - processes PGID */
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (settings.procpgid_check),	
  gconf_client_get_bool (client, gconf_concat_dir_and_key (settings.gconf_path_settings, "procpgid"), NULL) );
  gtk_entry_set_text (GTK_ENTRY (settings.procpgid_entry), 
  gconf_client_get_string (client, gconf_concat_dir_and_key (settings.gconf_path_settings, "procpgid_entry"), NULL) );
  
  /* processes - display directory */
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (settings.dispdir_check),	
  gconf_client_get_bool (client, gconf_concat_dir_and_key (settings.gconf_path_settings, "disdir"), NULL) );
  gtk_entry_set_text (GTK_ENTRY (settings.dispdir_entry), 
  gconf_client_get_string (client, gconf_concat_dir_and_key (settings.gconf_path_settings, "disdir_entry"), NULL) );
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (settings.dispdir_depth_check), 
  gconf_client_get_bool (client, gconf_concat_dir_and_key (settings.gconf_path_settings, "depth"), NULL) );
  
  /* processes - files descriptors */
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (settings.fd_check),	
  gconf_client_get_bool (client, gconf_concat_dir_and_key (settings.gconf_path_settings, "fdlistdesc"), NULL) );
  gtk_entry_set_text (GTK_ENTRY (settings.fd_entry), 
  gconf_client_get_string (client, gconf_concat_dir_and_key (settings.gconf_path_settings, "fdlistdesc_entry"), NULL) );
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (settings.fd_include_radio), 
  gconf_client_get_bool (client, gconf_concat_dir_and_key (settings.gconf_path_settings, "incexc"), NULL) );
  
  /* processes - list of files for id or username */
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (settings.iduname_check), 
  gconf_client_get_bool (client, gconf_concat_dir_and_key (settings.gconf_path_settings, "listidname"), NULL) );
  gtk_entry_set_text (GTK_ENTRY (settings.iduname_entry), 
  gconf_client_get_string (client, gconf_concat_dir_and_key (settings.gconf_path_settings, "listidname_entry"), NULL) );
  
  /* processes - max number of links for a file */
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (settings.nlinks_check),	
  gconf_client_get_bool (client, gconf_concat_dir_and_key (settings.gconf_path_settings, "numberlinks"), NULL) );
  gtk_spin_button_set_value (GTK_SPIN_BUTTON (settings.nlinks_entry), 
  (gdouble) gconf_client_get_int (client, gconf_concat_dir_and_key (settings.gconf_path_settings, "numberlinks_entry"), NULL) );
  
  /* network - list of files for internet addresses */
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (settings.inetaddr_check),	
  gconf_client_get_bool (client, gconf_concat_dir_and_key (settings.gconf_path_settings, "internetadds"), NULL));
    
  /***************************/
  /* add_list - internetadds */
  /***************************/
  
  list_strings = gconf_client_get_list (client, gconf_concat_dir_and_key (settings.gconf_path_settings, "internet_list"), GCONF_VALUE_STRING, NULL);
  
  list_length = g_slist_length(list_strings) / 5;
  
  if (list_length > 0)
  {
	  guint l=0;
	  guint i;
	  
	  for (i = 0; i<list_length; i++)
	  {
		  gchar *buffer;
		  GtkTreeIter iter;
		  
		  /* Create new struct on heap - zero's memory */
		  node_data *tmp_node = g_new0 (node_data, 1);
		  
		  buffer = g_slist_nth_data (list_strings, l);
		  tmp_node->host = g_strdup (buffer);
		  g_free (buffer);
		  l++;
		  
		  buffer = g_slist_nth_data (list_strings, l);
		  tmp_node->port = g_strdup (buffer);
		  g_free (buffer);
		  l++;
		  
		  buffer = g_slist_nth_data (list_strings, l);
		  tmp_node->ipv = g_strdup (buffer);
		  g_free (buffer);
		  l++;
		  
		  buffer = g_slist_nth_data (list_strings, l);
		  tmp_node->protocol = g_strdup (buffer);
		  g_free (buffer);
		  l++;
		  
		  buffer = g_slist_nth_data (list_strings, l);
		  tmp_node->option = g_strdup (buffer);
		  /* copy on list_store */
		  gtk_list_store_append (GTK_LIST_STORE (lia.liststore_right), &iter);
		  gtk_list_store_set (lia.liststore_right, &iter, 0, i+1, 1, tmp_node->option, -1);
		  g_free (buffer);
		  l++;
		  
		  g_ptr_array_add (add_list, (gpointer) tmp_node);
	  }
  }
  
  g_slist_free (list_strings);
  
  /* network - display ip-form addresses */
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (settings.ipform_check),
  gconf_client_get_bool (client, gconf_concat_dir_and_key (settings.gconf_path_settings, "ipadds"), NULL) );
  
  /* network - port number */
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (settings.portnumbers_check),
  gconf_client_get_bool (client, gconf_concat_dir_and_key (settings.gconf_path_settings, "ports"), NULL) );
  
  /* network - nfs */
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (settings.nfs_check), 
  gconf_client_get_bool (client, gconf_concat_dir_and_key (settings.gconf_path_settings, "nfs"), NULL) );
  
  /* network - unix sockets */
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (settings.unixsockets_check),
  gconf_client_get_bool (client, gconf_concat_dir_and_key (settings.gconf_path_settings, "unixsockets"), NULL) );
  
  /* kernel - timeout seconds */
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (settings.timeout_check),
  gconf_client_get_bool (client, gconf_concat_dir_and_key (settings.gconf_path_settings, "timeoutsecs"), NULL) );
  gtk_spin_button_set_value (GTK_SPIN_BUTTON (settings.timeout_entry), 
  (gdouble) gconf_client_get_int (client, gconf_concat_dir_and_key (settings.gconf_path_settings, "timeoutsecs_entry"), NULL) );

  /* kernel - avoid */
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (settings.avoid_check), 
  gconf_client_get_bool (client, gconf_concat_dir_and_key (settings.gconf_path_settings, "avoid"), NULL) );
}

void 
save_sets (void)
{
  GSList *list_strings = NULL;
  guint array_length;

  /* general - id or login */
  gconf_client_set_bool (client, gconf_concat_dir_and_key (settings.gconf_path_settings, "id"),
	gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (settings.id_radio)) ,NULL );
  gconf_client_set_bool (client, gconf_concat_dir_and_key (settings.gconf_path_settings, "login"), 
	gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (settings.login_radio)) ,NULL );
	
  /* general - offset or size */
  gconf_client_set_bool (client, gconf_concat_dir_and_key (settings.gconf_path_settings, "offset"),
	gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (settings.offset_radio)) ,NULL );
  gconf_client_set_bool (client, gconf_concat_dir_and_key (settings.gconf_path_settings, "size"), 
	gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (settings.size_radio)) ,NULL );
	
  /* general - all AND */
  gconf_client_set_bool (client, gconf_concat_dir_and_key (settings.gconf_path_settings, "and"),
	gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (settings.and_check)) ,NULL );
	
  /* general - hide 'lsof' and 'glsof' from output*/
  gconf_client_set_bool (client, gconf_concat_dir_and_key (settings.gconf_path_settings, "hideglsof"),
	gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (settings.hideglsof_check)) ,NULL );
	  
  /* files - processes name exec */
  gconf_client_set_bool (client, gconf_concat_dir_and_key (settings.gconf_path_settings, "procexe"),
	gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (settings.procexe_check)) ,NULL );
  gconf_client_set_string (client, gconf_concat_dir_and_key (settings.gconf_path_settings, "procexe_entry"), 
	gtk_entry_get_text (GTK_ENTRY (settings.procexe_entry)) ,NULL );
	
  /* files - processes ID */
  gconf_client_set_bool (client, gconf_concat_dir_and_key (settings.gconf_path_settings, "procid"),
	gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (settings.procid_check)) ,NULL );
  gconf_client_set_string (client, gconf_concat_dir_and_key (settings.gconf_path_settings, "procid_entry"), 
	gtk_entry_get_text (GTK_ENTRY (settings.procid_entry)) ,NULL );
	
  /* files - processes PGID */
  gconf_client_set_bool (client, gconf_concat_dir_and_key (settings.gconf_path_settings, "procpgid"),
	gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (settings.procpgid_check)) ,NULL );
  gconf_client_set_string (client, gconf_concat_dir_and_key (settings.gconf_path_settings, "procpgid_entry"), 
	gtk_entry_get_text (GTK_ENTRY (settings.procpgid_entry)) ,NULL );
	
  /* processes - display directory */
  gconf_client_set_bool (client, gconf_concat_dir_and_key (settings.gconf_path_settings, "disdir"),
	gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (settings.dispdir_check)) ,NULL );
  gconf_client_set_string (client, gconf_concat_dir_and_key (settings.gconf_path_settings, "disdir_entry"), 
	gtk_entry_get_text (GTK_ENTRY (settings.dispdir_entry)) ,NULL );
  gconf_client_set_bool (client, gconf_concat_dir_and_key (settings.gconf_path_settings, "depth"),
	gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (settings.dispdir_depth_check)) ,NULL );
  
  /* processes - files descriptors */
  gconf_client_set_bool (client, gconf_concat_dir_and_key (settings.gconf_path_settings, "fdlistdesc"),
	gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (settings.fd_check)) ,NULL );
  gconf_client_set_string (client, gconf_concat_dir_and_key (settings.gconf_path_settings, "fdlistdesc_entry"), 
	gtk_entry_get_text (GTK_ENTRY (settings.fd_entry)) ,NULL );
  gconf_client_set_bool (client, gconf_concat_dir_and_key (settings.gconf_path_settings, "incexc"),
	gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (settings.fd_include_radio)) ,NULL );
	
  /* processes - list of files for id or username */
  gconf_client_set_bool (client, gconf_concat_dir_and_key (settings.gconf_path_settings, "listidname"),
	gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (settings.iduname_check)) ,NULL );
  gconf_client_set_string (client, gconf_concat_dir_and_key (settings.gconf_path_settings, "listidname_entry"), 
	gtk_entry_get_text (GTK_ENTRY (settings.iduname_entry)) ,NULL );
	
  /* processes - max number of links for a file */
  gconf_client_set_bool (client, gconf_concat_dir_and_key (settings.gconf_path_settings, "numberlinks"),
	gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (settings.nlinks_check)) ,NULL );
  gconf_client_set_int (client, gconf_concat_dir_and_key (settings.gconf_path_settings, "numberlinks_entry"), 
	gtk_spin_button_get_value_as_int (GTK_SPIN_BUTTON (settings.nlinks_entry)) ,NULL );
	
  /* network - list of files for internet addresses */
  gconf_client_set_bool (client, gconf_concat_dir_and_key (settings.gconf_path_settings, "internetadds"),
	gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (settings.inetaddr_check)) ,NULL );
	
  /***************************/
  /* add_list - internetadds */
  /***************************/
  
  array_length = add_list->len;
  
  if (array_length > 0)
  {
	  guint i;
	  node_data *tmp_node;
	  
	  for (i = 0; i<array_length; i++)
	  {
		  tmp_node = g_ptr_array_index (add_list, i);

		  list_strings = g_slist_append (list_strings, (gpointer) g_strdup(tmp_node->host));
		  list_strings = g_slist_append (list_strings, (gpointer) g_strdup(tmp_node->port));
		  list_strings = g_slist_append (list_strings, (gpointer) g_strdup(tmp_node->ipv));
		  list_strings = g_slist_append (list_strings, (gpointer) g_strdup(tmp_node->protocol));
		  list_strings = g_slist_append (list_strings, (gpointer) g_strdup(tmp_node->option));
	  }
  }
  
  gconf_client_set_list (client, gconf_concat_dir_and_key (settings.gconf_path_settings, "internet_list"), GCONF_VALUE_STRING, list_strings, NULL);
  
  g_slist_free (list_strings);
  
  /* network - display ip-form addresses */
  gconf_client_set_bool (client, gconf_concat_dir_and_key (settings.gconf_path_settings, "ipadds"),
	gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (settings.ipform_check)) ,NULL );
	
  /* network - port number */
  gconf_client_set_bool (client, gconf_concat_dir_and_key (settings.gconf_path_settings, "ports"),
	gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (settings.portnumbers_check)) ,NULL );
	
  /* network - nfs */
  gconf_client_set_bool (client, gconf_concat_dir_and_key (settings.gconf_path_settings, "nfs"),
	gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (settings.nfs_check)) ,NULL );
  
  /* network - unix sockets */
  gconf_client_set_bool (client, gconf_concat_dir_and_key (settings.gconf_path_settings, "unixsockets"),
	gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (settings.unixsockets_check)) ,NULL );
	
  /* kernel - timeout seconds */
  gconf_client_set_bool (client, gconf_concat_dir_and_key (settings.gconf_path_settings, "timeoutsecs"),
	gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (settings.timeout_check)) ,NULL );
  gconf_client_set_int (client, gconf_concat_dir_and_key (settings.gconf_path_settings, "timeoutsecs_entry"), 
	gtk_spin_button_get_value_as_int (GTK_SPIN_BUTTON (settings.timeout_entry)) ,NULL );
	
  /* kernel - avoid */
  gconf_client_set_bool (client, gconf_concat_dir_and_key (settings.gconf_path_settings, "avoid"),
	gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (settings.avoid_check)) ,NULL );
}

/*******************/
/* Settings Window */
/*******************/
void
change_title_settings_window (void)
{
	gchar *tmp_title;
	
	/* change title */
	tmp_title = g_strconcat ("Editing Profile \"",settings.save_new_settings_name,"\"",NULL);
	gtk_window_set_title (GTK_WINDOW(settings.window), tmp_title);
	g_free (tmp_title);
}


void
on_settings_clicked (GtkButton * button, gpointer user_data)
{
	change_title_settings_window();
	gtk_widget_show (settings.window);
}

void
make_settings_window (void)
{
  GladeXML *xml_glade;
  GtkTooltips *button_bar_tips;

  button_bar_tips = gtk_tooltips_new ();
	
  xml_glade = glade_xml_new (GLADE_PATH"glsof_settings.glade", NULL, NULL);
	
  /* window */
  settings.window = glade_xml_get_widget (xml_glade, "glsof-settings");

  /* general - id or login name */
  settings.id_radio =  glade_xml_get_widget (xml_glade, "radiobutton5");
  gtk_tooltips_set_tip (GTK_TOOLTIPS (button_bar_tips), settings.id_radio,
			_("(-l) For example display '501' and not user name 'gnele'."),	NULL);
  settings.login_radio = glade_xml_get_widget (xml_glade, "radiobutton6");
  gtk_tooltips_set_tip (GTK_TOOLTIPS (button_bar_tips), settings.login_radio,
			_("For example display 'gnele' and not user ID '501'."), NULL);
  
  /* general - offset or size */
  settings.offset_radio =  glade_xml_get_widget (xml_glade, "radiobutton7");
  settings.size_radio =  glade_xml_get_widget (xml_glade, "radiobutton8");
  
  /* general - AND all settings */
  settings.and_check = glade_xml_get_widget (xml_glade, "checkbutton2");

  /* general - avoid "glsof" and "lsof" in output */
  settings.hideglsof_check = glade_xml_get_widget (xml_glade, "checkbutton3");


  /* files - processes executing */
  settings.procexe_check = glade_xml_get_widget (xml_glade, "checkbutton15");
  gtk_tooltips_set_tip (GTK_TOOLTIPS (button_bar_tips), settings.procexe_check,
			_("(-c) Use comma-separated (no spaces). For example 'awk,perl,gimp,..'."),	NULL);
  settings.procexe_entry = glade_xml_get_widget (xml_glade, "entry21");
  
  /* files - processes id */
  settings.procid_check = glade_xml_get_widget (xml_glade, "checkbutton16");
  gtk_tooltips_set_tip (GTK_TOOLTIPS (button_bar_tips), settings.procid_check,
			_("(-p) Use comma-separated (no spaces). For example '123,456,..'."),	NULL);
  settings.procid_entry = glade_xml_get_widget (xml_glade, "entry22");
  
  /* files - processes pgid */
  settings.procpgid_check = glade_xml_get_widget (xml_glade, "checkbutton17");
  gtk_tooltips_set_tip (GTK_TOOLTIPS (button_bar_tips), settings.procpgid_check,
			_("(-g) Use comma-separated (no spaces). For example '123,456,...'."),NULL);
  settings.procpgid_entry = glade_xml_get_widget (xml_glade, "entry23");
  

  /* processes - display directory */
  settings.dispdir_check =  glade_xml_get_widget (xml_glade, "checkbutton18");
  gtk_tooltips_set_tip (GTK_TOOLTIPS (button_bar_tips), settings.dispdir_check,
			_("(+d) NOT descend the directory tree . 'Complete depth' (+D) descend the directory tree."),	NULL);
  settings.dispdir_entry = glade_xml_get_widget (xml_glade, "entry24");
  settings.dispdir_depth_check = glade_xml_get_widget (xml_glade, "checkbutton22");
  
  /* processes - file descriptors */
  settings.fd_check = glade_xml_get_widget (xml_glade, "checkbutton19");
  gtk_tooltips_set_tip (GTK_TOOLTIPS (button_bar_tips), settings.fd_check,
			_("(-d) Use comma-separated (no spaces). For example 'txt,1,3,...'."),NULL);
  settings.fd_entry = glade_xml_get_widget (xml_glade, "entry25");
  settings.fd_include_radio = glade_xml_get_widget (xml_glade, "radiobutton12");
  settings.fd_exclude_radio = glade_xml_get_widget (xml_glade, "radiobutton13");

  /* processes - files for id or username */
  settings.iduname_check = glade_xml_get_widget (xml_glade, "checkbutton20");
  gtk_tooltips_set_tip (GTK_TOOLTIPS (button_bar_tips), settings.iduname_check,
			_("(-u) Use comma-separated (no spaces). For example 'root,548,gnele,...'."),	NULL);
  settings.iduname_entry = glade_xml_get_widget (xml_glade, "entry26");
  
  /* processes - max number of links for a file */
  settings.nlinks_check = glade_xml_get_widget (xml_glade, "checkbutton21");
  settings.nlinks_entry = glade_xml_get_widget (xml_glade, "spinbutton2");


   /* network - internet addresses */
   settings.inetaddr_check = glade_xml_get_widget (xml_glade, "checkbutton4");
   gtk_tooltips_set_tip (GTK_TOOLTIPS (button_bar_tips), settings.inetaddr_check,
			_("(-i) [46][protocol][@hostname|hostaddr][:service|port]"),NULL);
   settings.inetaddr_button = glade_xml_get_widget (xml_glade, "button5");
  
  /* network - ip-form */
  settings.ipform_check = glade_xml_get_widget (xml_glade, "checkbutton5");
  
  /* network - nfs */
  settings.nfs_check = glade_xml_get_widget (xml_glade, "checkbutton6");
  
  /* network - port numbers */
  settings.portnumbers_check = glade_xml_get_widget (xml_glade, "checkbutton7");

  /* network - unix sockets */
  settings.unixsockets_check = glade_xml_get_widget (xml_glade, "checkbutton8");
  
  /* kernel - timeout seconds */
  settings.timeout_check = glade_xml_get_widget (xml_glade, "checkbutton9");
  settings.timeout_entry = glade_xml_get_widget (xml_glade, "spinbutton1");

  /* kernel - avoid */
  settings.avoid_check = glade_xml_get_widget (xml_glade, "checkbutton10");
  
  /* active all signals */
  glade_xml_signal_autoconnect(xml_glade);
	  
  g_object_unref(G_OBJECT(xml_glade));
}
