/*  settings - save and load datas for 'settings' and make settings-window.
    Copyright (C) 2004  Daniele F.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA  */

/* For bugs or infos please contact me <geekgnele@tin.it> */


#ifndef SETTINGS_H
#define SETTINGS_H

void
on_settings_clicked (GtkButton *, gpointer);

void
make_settings_window (void);

void
load_sets (void);

void
save_sets (void);

void
change_title_settings_window(void);

struct _settings_window {
	
	/* Main Window */
	GtkWidget *window;
	
	/* General */
	GtkWidget *id_radio;
	GtkWidget *login_radio;
	GtkWidget *offset_radio;
	GtkWidget *size_radio;
	GtkWidget *and_check;
	GtkWidget *hideglsof_check;
	
	/* Files */
	GtkWidget *procexe_check;
	GtkWidget *procexe_entry;
	GtkWidget *procid_check;
	GtkWidget *procid_entry;
	GtkWidget *procpgid_check;
	GtkWidget *procpgid_entry;
	
	/* Processes */
	GtkWidget *dispdir_check;
	GtkWidget *dispdir_entry;
	GtkWidget *dispdir_depth_check;
	GtkWidget *fd_check;
	GtkWidget *fd_entry;
	GtkWidget *fd_include_radio;
	GtkWidget *fd_exclude_radio;
	GtkWidget *iduname_check;
	GtkWidget *iduname_entry;
	GtkWidget *nlinks_check;
	GtkWidget *nlinks_entry;
	
	/* Network */
	GtkWidget *inetaddr_check;
	GtkWidget *inetaddr_button;
	GtkWidget *ipform_check;
	GtkWidget *nfs_check;
	GtkWidget *portnumbers_check;
	GtkWidget *unixsockets_check;
	
	/* Kernel */
	GtkWidget *timeout_check;
	GtkWidget *timeout_entry;
	GtkWidget *avoid_check;
	
	gchar *save_new_settings_name;
	gchar *gconf_path_settings;
};

typedef struct _settings_window settings_window;

#endif /* SETTINGS_H */
